SystemOrganization addCategory: #'MatchingBenchmarkPlatform-Model'!
SystemOrganization addCategory: #'MatchingBenchmarkPlatform-View'!
SystemOrganization addCategory: #'MatchingBenchmarkPlatform-Core'!

WAComponent subclass: #MBPBenchmarklistComponent
	instanceVariableNames: 'report currentView detailsView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-View'!

!MBPBenchmarklistComponent methodsFor: 'actions' stamp: 'dt 1/7/2008 11:20'!
benchmarkDetails: aMBPBenchmark

	self detailsView benchmark: aMBPBenchmark.
	self currentView: self detailsView.! !

!MBPBenchmarklistComponent methodsFor: 'actions' stamp: 'dt 1/9/2008 10:45'!
buildReport
	report := MAReport 
		rows: self session database benchmarks
		description: MBPBenchmark reportDescription.
	report addColumn: (MACommandColumn new 
			addCommandOn: self
			selector: #benchmarkDetails:
			text: 'Show Details').
	^ report! !

!MBPBenchmarklistComponent methodsFor: 'accessing' stamp: 'dt 1/7/2008 11:18'!
children

	^Array with: self currentView ! !

!MBPBenchmarklistComponent methodsFor: 'accessing' stamp: 'dt 1/7/2008 11:18'!
currentView
	^ currentView! !

!MBPBenchmarklistComponent methodsFor: 'accessing' stamp: 'dt 1/7/2008 11:18'!
currentView: anObject
	currentView := anObject! !

!MBPBenchmarklistComponent methodsFor: 'accessing' stamp: 'dt 1/7/2008 11:34'!
detailsView
	^ detailsView
		ifNil: [ detailsView := MBPDetailedBenchmarkComponent new.
				detailsView onAnswer: [:answer | self currentView: self report].
				detailsView ]! !

!MBPBenchmarklistComponent methodsFor: 'accessing' stamp: 'dt 1/7/2008 11:21'!
detailsView: anObject
	detailsView := anObject! !

!MBPBenchmarklistComponent methodsFor: 'initialize-release' stamp: 'dt 1/7/2008 11:24'!
initialize

	super initialize.
	self currentView: self report! !

!MBPBenchmarklistComponent methodsFor: 'rendering' stamp: 'dt 1/7/2008 11:18'!
renderContentOn: html

	html render: self currentView  ! !

!MBPBenchmarklistComponent methodsFor: 'accessing' stamp: 'dt 1/7/2008 11:23'!
report
	^ report ifNil: [self buildReport]! !

!MBPBenchmarklistComponent methodsFor: 'accessing' stamp: 'dt 1/6/2008 14:39'!
report: anObject
	report := anObject! !

WAComponent subclass: #MBPDetailedBenchmarkComponent
	instanceVariableNames: 'benchmark items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-View'!

!MBPDetailedBenchmarkComponent methodsFor: 'accessing' stamp: 'dt 1/7/2008 11:23'!
benchmark
	^ benchmark! !

!MBPDetailedBenchmarkComponent methodsFor: 'accessing' stamp: 'dt 1/12/2008 16:46'!
benchmark: anObject
	benchmark := anObject! !

!MBPDetailedBenchmarkComponent methodsFor: 'accessing' stamp: 'dt 1/7/2008 13:37'!
items
	^ items ifNil: [ items := self session database results select: [:each | each benchmark = self benchmark]]! !

!MBPDetailedBenchmarkComponent methodsFor: 'accessing' stamp: 'dt 1/7/2008 13:37'!
items: anObject
	items := anObject! !

!MBPDetailedBenchmarkComponent methodsFor: 'rendering' stamp: 'dt 1/7/2008 11:28'!
renderBackButtonOn: html

	html paragraph with: [
		html anchor
			callback: [self answer: #back];
			with: 'Back to list'
		]! !

!MBPDetailedBenchmarkComponent methodsFor: 'rendering' stamp: 'dt 1/9/2008 19:19'!
renderBenchmarkResultsOn: html
	
	html paragraph with: [
		html text: 'Benchmarkresults for this Benchmark:'].! !

!MBPDetailedBenchmarkComponent methodsFor: 'rendering' stamp: 'dt 1/12/2008 16:43'!
renderContentOn: html 
	html render: (MBPBenchmark detailsDescription asComponentOn: self benchmark) yourself.

	self renderStatisticsForBenchmarkOn: html.
	self renderBackButtonOn: html! !

!MBPDetailedBenchmarkComponent methodsFor: 'rendering' stamp: 'dt 1/12/2008 17:03'!
renderStatisticsForBenchmarkOn: html

	| testcases results |
	self halt.
	testcases := (self session database results select: [:each | each benchmark = self benchmark])
		inject: OrderedCollection new into: [:total :current | total addAll: current testcaseResults].

	results := Dictionary new.
	#(#truePositives #trueNegatives #falsePositives #falseNegatives) do: [:each |
		results at: each put: ((testcases collect: [:aMBPTestCaseResult | aMBPTestCaseResult statistics at: each]) sum / testcases size)
		].

	html div
		id: 'Average';
		with: [
			html googleChart
				threeDimensionalPieChart;
				width: 500; height: 200;
				addDataSet: (GCDataSet new
					data: (Array
						with: (results at: #truePositives)
						with: (results at: #falsePositives)
						with: (results at: #trueNegatives)
						with: (results at: #falseNegatives));
					yourself);
				pieChartLabels: #('True Positives' 'False Positives' 'True Negatives' 'False negatives')
			]
! !

!MBPDetailedBenchmarkComponent methodsFor: 'private' stamp: 'dt 1/7/2008 13:21'!
showStatisticsFor: aMBPMatchingResult
	
	self inform: 'Juppeeee'! !

WAComponent subclass: #MBPHomeComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-View'!

!MBPHomeComponent methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 09:56'!
renderContentOn: html

	html heading
		level: 2;
		with: 'Home view. This is the MBP bla blub'! !

WAComponent subclass: #MBPInputComponent
	instanceVariableNames: 'modelComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-View'!

!MBPInputComponent class methodsFor: 'as yet unclassified' stamp: 'dt 1/5/2008 18:46'!
for: aClass

	^self new
		modelComponent: aClass new asComponent addValidatedForm! !

!MBPInputComponent methodsFor: 'accessing' stamp: 'dt 1/5/2008 18:46'!
children

	^Array with: self modelComponent ! !

!MBPInputComponent methodsFor: 'as yet unclassified' stamp: 'dt 1/12/2008 14:43'!
clearAnswerHandler
| collection |
	collection := OrderedCollection new.
	self decorationChainDo: [:e | collection add: e].
	collection
		select: [:each | each isKindOf: WAAnswerHandler]
		thenDo: [:each | self removeDecoration: each].! !

!MBPInputComponent methodsFor: 'accessing' stamp: 'dt 1/5/2008 18:46'!
modelComponent
	^ modelComponent! !

!MBPInputComponent methodsFor: 'accessing' stamp: 'dt 1/5/2008 18:46'!
modelComponent: anObject
	modelComponent := anObject! !

!MBPInputComponent methodsFor: 'rendering' stamp: 'dt 1/6/2008 13:10'!
renderContentOn: html

	html render: (self modelComponent onAnswer: [:answer | self answer: answer]; yourself).

	! !

WAComponent subclass: #MBPMainpage
	instanceVariableNames: 'matcherList currentView homeView uploadView inputView benchmarkList detailsView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-View'!

!MBPMainpage class methodsFor: 'as yet unclassified' stamp: 'dt 12/28/2007 13:22'!
canBeRoot

	^true! !

!MBPMainpage methodsFor: 'actions' stamp: 'dt 1/12/2008 14:25'!
addBenchmark

	self showInputViewFor: MBPBenchmark new	onAnswerDo: [ : answer |
		answer ifNotNil: [self session database addBenchmark: answer ].
		self viewHome ]! !

!MBPMainpage methodsFor: 'actions' stamp: 'dt 1/12/2008 14:43'!
addMatcher

	self showInputViewFor: MBPMatcher new onAnswerDo: [:answer |
		answer ifNotNil: [self session database addMatcher: answer].
		self viewHome ]! !

!MBPMainpage methodsFor: 'actions' stamp: 'dt 1/12/2008 14:43'!
addPerson

	self showInputViewFor: MBPPerson new onAnswerDo: [:answer |
		answer ifNotNil: [self session database addPerson: answer].
		self viewHome ]! !

!MBPMainpage methodsFor: 'actions' stamp: 'dt 1/6/2008 13:40'!
addPublication

	self showInputViewFor: MBPPublication new onAnswerDo: [:answer |
		answer ifNotNil: [self session database addPublication: answer].
		self viewHome ]! !

!MBPMainpage methodsFor: 'actions' stamp: 'dt 1/12/2008 14:25'!
addResult

	self showInputViewFor: MBPBenchmarkResult new onAnswerDo: [ : answer |
		answer ifNotNil: [self session database addResult: answer ].
		self viewHome ]! !

!MBPMainpage methodsFor: 'accessing' stamp: 'dt 1/7/2008 10:53'!
benchmarkList
	^ benchmarkList ifNil: [ benchmarkList := MBPBenchmarklistComponent new ]! !

!MBPMainpage methodsFor: 'accessing' stamp: 'dt 1/6/2008 14:34'!
benchmarkList: anObject
	benchmarkList := anObject! !

!MBPMainpage methodsFor: 'accessing' stamp: 'dt 12/30/2007 11:42'!
children

	^Array with: self currentView! !

!MBPMainpage methodsFor: 'accessing' stamp: 'dt 12/30/2007 09:50'!
currentView
	^ currentView! !

!MBPMainpage methodsFor: 'accessing' stamp: 'dt 12/30/2007 09:50'!
currentView: anObject
	currentView := anObject! !

!MBPMainpage methodsFor: 'accessing' stamp: 'dt 1/7/2008 11:22'!
detailsView
	^ detailsView ifNil: [ detailsView := MBPDetailedBenchmarkComponent new ]! !

!MBPMainpage methodsFor: 'accessing' stamp: 'dt 1/7/2008 10:51'!
detailsView: anObject
	detailsView := anObject! !

!MBPMainpage methodsFor: 'accessing' stamp: 'dt 1/7/2008 10:53'!
homeView
	^ homeView ifNil: [ homeView := MBPHomeComponent new ]! !

!MBPMainpage methodsFor: 'accessing' stamp: 'dt 12/30/2007 09:57'!
homeView: anObject
	homeView := anObject! !

!MBPMainpage methodsFor: 'initialize-release' stamp: 'dt 1/7/2008 10:52'!
initialize

	super initialize.
	self currentView: self homeView.! !

!MBPMainpage methodsFor: 'accessing' stamp: 'dt 1/7/2008 10:52'!
inputView
	^ inputView ifNil: [ inputView := MBPInputComponent new]! !

!MBPMainpage methodsFor: 'accessing' stamp: 'dt 1/5/2008 18:41'!
inputView: anObject
	inputView := anObject! !

!MBPMainpage methodsFor: 'accessing' stamp: 'dt 1/7/2008 10:54'!
matcherList
	^ matcherList ifNil: [ matcherList := MBPMatcherlistComponent new ]! !

!MBPMainpage methodsFor: 'accessing' stamp: 'dt 12/30/2007 09:48'!
matcherList: anObject
	matcherList := anObject! !

!MBPMainpage methodsFor: 'rendering' stamp: 'dt 12/30/2007 09:50'!
renderBodyOn: html


	html div
		id: 'content';
		with: [
			html render: self currentView]! !

!MBPMainpage methodsFor: 'rendering' stamp: 'dt 12/30/2007 09:53'!
renderContentOn: html


	self
		renderHeaderOn: html;
		renderNavigationOn: html;
		renderBodyOn: html! !

!MBPMainpage methodsFor: 'rendering' stamp: 'dt 12/28/2007 15:05'!
renderHeaderOn: html 

	html div
		id: 'header';
		with: [
			html heading
				level: 1;
				with: MBPConfiguration applicationName]! !

!MBPMainpage methodsFor: 'rendering' stamp: 'dt 1/6/2008 15:22'!
renderNavigationLinksOn: html

	html anchor
		callback: [ self viewHome];
		with: 'Home'.
		
	html anchor
		callback: [self addPerson];
		with: 'Add Person'.
		
	html anchor
		callback: [self addPublication];
		with: 'Submit Publication'.
		
	html anchor
		callback: [self addMatcher];
		with: 'Add Matcher'.
		
	html anchor
		callback: [ self viewMatchers];
		with: 'View Matchers'.
		
	html anchor
		callback: [ self viewBenchmarks];
		with: 'View Benchmarks'.
		
	html anchor
		callback: [ self addBenchmark];
		with: 'Add Benchmark'.
		
	html anchor
		callback: [ self addResult];
		with: 'Upload your matching result'.! !

!MBPMainpage methodsFor: 'rendering' stamp: 'dt 12/28/2007 14:20'!
renderNavigationOn: html
		
	html div
		id: 'navigation';
		with: [
			self renderNavigationLinksOn: html]! !

!MBPMainpage methodsFor: 'private' stamp: 'dt 1/12/2008 14:45'!
showInputViewFor: anObject onAnswerDo: aBlock

	self inputView
		modelComponent: anObject asComponent addValidatedForm;
		clearAnswerHandler;
		onAnswer: [:answer | aBlock value: answer].
	self currentView: self inputView ! !

!MBPMainpage methodsFor: 'actions' stamp: 'dt 1/6/2008 14:33'!
viewBenchmarks

	self currentView: self benchmarkList! !

!MBPMainpage methodsFor: 'actions' stamp: 'dt 12/30/2007 09:57'!
viewHome
		
	self currentView: self homeView! !

!MBPMainpage methodsFor: 'actions' stamp: 'dt 12/30/2007 09:50'!
viewMatchers
		
	self currentView: self matcherList! !

WAComponent subclass: #MBPMatcherlistComponent
	instanceVariableNames: 'report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-View'!

!MBPMatcherlistComponent methodsFor: 'actions' stamp: 'dt 12/30/2007 10:44'!
buildReport

	report := MAReport rows: self session database matchers
									description: MBPMatcher description.
									
								
	report addColumn: (MACommandColumn new
		addCommandOn: self selector: #matcherDetails: text: 'Show Details')! !

!MBPMatcherlistComponent methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:11'!
children

	^OrderedCollection with: report! !

!MBPMatcherlistComponent methodsFor: 'initialize-release' stamp: 'dt 12/30/2007 09:51'!
initialize

	super initialize.
	self buildReport ! !

!MBPMatcherlistComponent methodsFor: 'actions' stamp: 'dt 12/30/2007 10:46'!
matcherDetails: aMBPMatcher

	self inform: 'Ist noch nichts... Hier kann dann coole Auswertung und so hin'! !

!MBPMatcherlistComponent methodsFor: 'rendering' stamp: 'dt 12/30/2007 09:47'!
renderContentOn: html

	html render: self report ! !

!MBPMatcherlistComponent methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:12'!
report
	^ report! !

!MBPMatcherlistComponent methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:11'!
report: anObject
	report := anObject! !

WASession subclass: #MBPSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-Core'!

!MBPSession methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:10'!
database

	^MBPDatabase default! !

!MBPSession methodsFor: 'initializing' stamp: 'dt 12/28/2007 15:06'!
initialize

	super initialize ! !

Object subclass: #MBPBenchmark
	instanceVariableNames: 'submitter comment uri benchmarkTitle testcases'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-Model'!

!MBPBenchmark class methodsFor: 'as yet unclassified' stamp: 'dt 1/8/2008 22:25'!
descriptionBenchmarkTitle

	^MAStringDescription new
		selectorAccessor: #benchmarkTitle;
		label: 'Benchmark Name';
		priority: 10;
		beRequired;
		yourself! !

!MBPBenchmark class methodsFor: 'as yet unclassified' stamp: 'dt 1/8/2008 22:26'!
descriptionComment

	^MAMemoDescription new
		selectorAccessor: #comment;
		label: 'Comment';
		priority: 20;
		beRequired;
		yourself! !

!MBPBenchmark class methodsFor: 'as yet unclassified' stamp: 'dt 1/8/2008 22:03'!
descriptionSubmitter

	^MASingleOptionDescription new
		selectorAccessor: #submitter;
		label: 'Submitter';
		priority: 20;
		options: [MBPDatabase default persons ] asDynamicObject;
		reference: ((MBPPerson descriptionContainer)
			add: MBPPerson descriptionFirstname;
			add: MBPPerson descriptionLastname;
			yourself);
		beRequired;
		yourself
			! !

!MBPBenchmark class methodsFor: 'as yet unclassified' stamp: 'dt 1/8/2008 22:26'!
descriptionTestcases

	^MAToManyRelationDescription new
		selectorAccessor: #testcases;
		label: 'Testcases';
		priority: 30;
		classes: (Array with: MBPTestCase);
		reference: MBPTestCase descriptionTestCaseTitle;
		default: OrderedCollection new;
		yourself! !

!MBPBenchmark class methodsFor: 'as yet unclassified' stamp: 'dt 1/9/2008 10:46'!
descriptionUri

	^MAStringDescription new
		selectorAccessor: #uri;
		label: 'URI';
		priority: 30;
		yourself! !

!MBPBenchmark class methodsFor: 'as yet unclassified' stamp: 'dt 1/9/2008 10:51'!
detailsDescription

	^self description collect: [:each | each copy beReadonly; yourself].
! !

!MBPBenchmark class methodsFor: 'as yet unclassified' stamp: 'dt 1/9/2008 10:47'!
reportDescription

	^self descriptionBenchmarkTitle, self descriptionComment! !

!MBPBenchmark methodsFor: 'accessing' stamp: 'dt 1/8/2008 22:04'!
benchmarkTitle
	^ benchmarkTitle! !

!MBPBenchmark methodsFor: 'accessing' stamp: 'dt 1/8/2008 22:04'!
benchmarkTitle: anObject
	benchmarkTitle := anObject! !

!MBPBenchmark methodsFor: 'accessing' stamp: 'dt 1/8/2008 22:06'!
comment
	^ comment! !

!MBPBenchmark methodsFor: 'accessing' stamp: 'dt 1/8/2008 22:06'!
comment: anObject
	comment := anObject! !

!MBPBenchmark methodsFor: 'printing' stamp: 'dt 1/12/2008 14:54'!
printOn: aStream

	aStream
		nextPutAll: self benchmarkTitle;
		nextPutAll: ', (';
		nextPutAll: self testcases size asString;
		nextPutAll: ' Testcases)'! !

!MBPBenchmark methodsFor: 'accessing' stamp: 'dt 1/8/2008 22:04'!
submitter
	^ submitter! !

!MBPBenchmark methodsFor: 'accessing' stamp: 'dt 1/8/2008 22:04'!
submitter: anObject
	submitter := anObject! !

!MBPBenchmark methodsFor: 'accessing' stamp: 'dt 1/8/2008 22:06'!
testcases
	^ testcases! !

!MBPBenchmark methodsFor: 'accessing' stamp: 'dt 1/8/2008 22:06'!
testcases: anObject
	testcases := anObject! !

!MBPBenchmark methodsFor: 'accessing' stamp: 'dt 1/8/2008 22:06'!
uri
	^ uri! !

!MBPBenchmark methodsFor: 'accessing' stamp: 'dt 1/8/2008 22:06'!
uri: anObject
	uri := anObject! !

Object subclass: #MBPBenchmarkResult
	instanceVariableNames: 'submitter comment licenseAccepted benchmark testcaseResults uploadDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-Model'!

!MBPBenchmarkResult class methodsFor: 'as yet unclassified' stamp: 'dt 1/9/2008 20:09'!
descriptionBenchmark

	^MASingleOptionDescription new
		selectorAccessor: #benchmark;
		label: 'Benchmark';
		options: [MBPDatabase default benchmarks ] asDynamicObject;
		reference: ((MBPBenchmark descriptionContainer)
			add: MBPBenchmark descriptionBenchmarkTitle)
			yourself;
		priority: 10;
		beRequired;
		yourself! !

!MBPBenchmarkResult class methodsFor: 'as yet unclassified' stamp: 'dt 1/9/2008 19:21'!
descriptionComment

	^MAMemoDescription new
		selectorAccessor: #comment;
		label: 'Comment';
		priority: 30;
		addCondition: [:value | value isNil or: [value size <= 20]] labelled: 'Your comment is not strong enugh';
		yourself
		! !

!MBPBenchmarkResult class methodsFor: 'as yet unclassified' stamp: 'dt 1/12/2008 16:24'!
descriptionContainer

	^(super descriptionContainer)
		addCondition: [:memento |
			true
			]
		labelled: 'You have not submitted results for each testcase';
		yourself! !

!MBPBenchmarkResult class methodsFor: 'as yet unclassified' stamp: 'dt 1/9/2008 19:21'!
descriptionLicenseAcceppted

	^MABooleanDescription new
		selectorAccessor: #licenseAccepted;
		label: 'Accept terms of use';
		priority: 100;
		addCondition: [:value | value = true] labelled: 'You must accepts the terms of use';
		yourself! !

!MBPBenchmarkResult class methodsFor: 'as yet unclassified' stamp: 'dt 1/9/2008 19:21'!
descriptionSubmitter

	^MASingleOptionDescription new
		selectorAccessor: #submitter;
		beRequired;
		label: 'Submitter';
		priority: 20;
		options: [MBPDatabase default persons] asDynamicObject;
		reference: (MBPPerson descriptionContainer
			add: MBPPerson descriptionFirstname;
			add: MBPPerson descriptionLastname;
			yourself);
		yourself! !

!MBPBenchmarkResult class methodsFor: 'as yet unclassified' stamp: 'dt 1/12/2008 15:41'!
descriptionTestcaseResults

	^MAToManyRelationDescription new
		selectorAccessor: #testcaseResults;
		label: 'Testcase Results';
		priority: 50;
		classes: (Array with: MBPTestCaseResult);
		reference: MBPTestCaseResult descriptionComment;
		default: OrderedCollection new;
		beRequired;
		yourself! !

!MBPBenchmarkResult class methodsFor: 'as yet unclassified' stamp: 'dt 1/9/2008 19:21'!
descriptionUploadDate

	^MADateDescription new
		selectorAccessor: #uploadDate;
		label: 'Upload Date';
		default: Date today;
		beReadonly;
		priority: 15;
		yourself! !

!MBPBenchmarkResult methodsFor: 'accessing' stamp: 'dt 1/9/2008 19:35'!
benchmark
	^ benchmark! !

!MBPBenchmarkResult methodsFor: 'accessing' stamp: 'dt 1/9/2008 19:35'!
benchmark: anObject
	benchmark := anObject! !

!MBPBenchmarkResult methodsFor: 'accessing' stamp: 'dt 1/9/2008 19:22'!
comment
	^ comment! !

!MBPBenchmarkResult methodsFor: 'accessing' stamp: 'dt 1/9/2008 19:22'!
comment: anObject
	comment := anObject! !

!MBPBenchmarkResult methodsFor: 'accessing' stamp: 'dt 1/9/2008 19:22'!
licenseAccepted
	^ licenseAccepted! !

!MBPBenchmarkResult methodsFor: 'accessing' stamp: 'dt 1/9/2008 19:22'!
licenseAccepted: anObject
	licenseAccepted := anObject! !

!MBPBenchmarkResult methodsFor: 'accessing' stamp: 'dt 1/9/2008 19:22'!
submitter
	^ submitter! !

!MBPBenchmarkResult methodsFor: 'accessing' stamp: 'dt 1/9/2008 19:22'!
submitter: anObject
	submitter := anObject! !

!MBPBenchmarkResult methodsFor: 'accessing' stamp: 'dt 1/9/2008 19:35'!
testcaseResults
	^ testcaseResults! !

!MBPBenchmarkResult methodsFor: 'accessing' stamp: 'dt 1/9/2008 19:35'!
testcaseResults: anObject
	testcaseResults := anObject! !

!MBPBenchmarkResult methodsFor: 'accessing' stamp: 'dt 1/9/2008 19:22'!
uploadDate
	^ uploadDate! !

!MBPBenchmarkResult methodsFor: 'accessing' stamp: 'dt 1/9/2008 19:22'!
uploadDate: anObject
	uploadDate := anObject! !

Object subclass: #MBPBenchmarkResultChecker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-Core'!

!MBPBenchmarkResultChecker class methodsFor: 'as yet unclassified' stamp: 'dt 1/7/2008 10:30'!
run

	self new run! !

!MBPBenchmarkResultChecker methodsFor: 'as yet unclassified' stamp: 'dt 1/12/2008 17:02'!
checkBenchmark: aMBPBenchmarkResult

	aMBPBenchmarkResult testcaseResults do: [:aMBPTestCaseResult |
		self checkTestCaseResult: aMBPTestCaseResult]! !

!MBPBenchmarkResultChecker methodsFor: 'as yet unclassified' stamp: 'dt 1/12/2008 16:34'!
checkTestCaseResult: aMBPTestCaseResult

	aMBPTestCaseResult statistics
		at: #truePositives put: 1;
		at: #falsePositives put: 2;
		at: #trueNegatives put: 3;
		at: #falseNegatives put: 4
! !

!MBPBenchmarkResultChecker methodsFor: 'as yet unclassified' stamp: 'dt 1/12/2008 16:30'!
run

	MBPDatabase default results do: [ :aMBPBenchmarkResult|
		self checkBenchmark: aMBPBenchmarkResult]! !

Object subclass: #MBPConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-Core'!

!MBPConfiguration class methodsFor: 'as yet unclassified' stamp: 'dt 12/28/2007 15:05'!
applicationName
	^ 'Matcher-Benchmark-Platform'! !

!MBPConfiguration class methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 11:02'!
licenseFilename

	^'license.txt'! !

Object subclass: #MBPDatabase
	instanceVariableNames: 'persons publications matchers results benchmarks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-Core'!

MBPDatabase class
	instanceVariableNames: 'default'!

MBPDatabase class
	instanceVariableNames: 'default'!

!MBPDatabase class methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:02'!
default

	^default ifNil: [default := self new]! !

!MBPDatabase class methodsFor: 'actions' stamp: 'dt 12/28/2007 15:02'!
resetDatabase

	default := nil! !

!MBPDatabase methodsFor: 'actions' stamp: 'dt 1/6/2008 14:45'!
addBenchmark: aMBPBenchmark

	self benchmarks add: aMBPBenchmark ! !

!MBPDatabase methodsFor: 'actions' stamp: 'dt 12/28/2007 15:08'!
addMatcher: aMBPMatcher

	self matchers add: aMBPMatcher ! !

!MBPDatabase methodsFor: 'actions' stamp: 'dt 12/30/2007 10:02'!
addPerson: aMBPPerson

	self persons add: aMBPPerson! !

!MBPDatabase methodsFor: 'actions' stamp: 'dt 12/30/2007 10:19'!
addPublication: aMBPPublication

	self publications add: aMBPPublication ! !

!MBPDatabase methodsFor: 'actions' stamp: 'dt 1/5/2008 16:29'!
addResult: aMBPResult

	self results add: aMBPResult ! !

!MBPDatabase methodsFor: 'accessing' stamp: 'dt 1/6/2008 14:42'!
benchmarks
	^ benchmarks! !

!MBPDatabase methodsFor: 'accessing' stamp: 'dt 1/6/2008 14:42'!
benchmarks: anObject
	benchmarks := anObject! !

!MBPDatabase methodsFor: 'initialize-release' stamp: 'dt 1/6/2008 14:43'!
initialize

	persons := OrderedCollection new.
	publications := OrderedCollection new.
	matchers := OrderedCollection new.
	results := OrderedCollection new.
	benchmarks := OrderedCollection new.! !

!MBPDatabase methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:08'!
matchers
	^ matchers! !

!MBPDatabase methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:08'!
matchers: anObject
	matchers := anObject! !

!MBPDatabase methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:01'!
persons
	^ persons! !

!MBPDatabase methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:01'!
persons: anObject
	persons := anObject! !

!MBPDatabase methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:01'!
publications
	^ publications! !

!MBPDatabase methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:01'!
publications: anObject
	publications := anObject! !

!MBPDatabase methodsFor: 'accessing' stamp: 'dt 1/5/2008 16:29'!
results
	^ results! !

!MBPDatabase methodsFor: 'accessing' stamp: 'dt 1/5/2008 16:29'!
results: anObject
	results := anObject! !

!MBPDatabase methodsFor: 'accessing' stamp: 'dt 1/8/2008 22:28'!
testCases

	^self benchmarks inject: OrderedCollection new into: [:all :current | all addAll: current testcases]! !

Object subclass: #MBPMatcher
	instanceVariableNames: 'matcherName vendor matcherDescription matcherUri publications'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-Model'!

!MBPMatcher class methodsFor: 'as yet unclassified' stamp: 'dt 12/28/2007 14:28'!
descriptionMatcherDescription

	^MAMemoDescription new
		selectorAccessor: #matcherDescription;
		label: 'Short description';
		priority: 20;
		beRequired;
		yourself! !

!MBPMatcher class methodsFor: 'as yet unclassified' stamp: 'dt 12/28/2007 14:34'!
descriptionMatcherName

	^MAStringDescription new
		selectorAccessor: #matcherName;
		label: 'Matcher Name';
		priority: 10;
		beRequired;
		yourself! !

!MBPMatcher class methodsFor: 'as yet unclassified' stamp: 'dt 12/28/2007 14:30'!
descriptionMatcherUri

	^MAStringDescription new
		selectorAccessor: #matcherUri;
		label: 'URI';
		priority: 40;
		yourself! !

!MBPMatcher class methodsFor: 'as yet unclassified' stamp: 'dt 12/28/2007 14:28'!
descriptionVendor

	^MAStringDescription new
		selectorAccessor: #vendor;
		label: 'Vendor';
		priority: 30;
		yourself! !

!MBPMatcher methodsFor: 'initialize-release' stamp: 'dt 12/28/2007 13:21'!
initialize

	publications := OrderedCollection new! !

!MBPMatcher methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:17'!
matcherDescription
	^ matcherDescription! !

!MBPMatcher methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:17'!
matcherDescription: anObject
	matcherDescription := anObject! !

!MBPMatcher methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:16'!
matcherName
	^ matcherName! !

!MBPMatcher methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:16'!
matcherName: anObject
	matcherName := anObject! !

!MBPMatcher methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:17'!
matcherUri
	^ matcherUri! !

!MBPMatcher methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:17'!
matcherUri: anObject
	matcherUri := anObject! !

!MBPMatcher methodsFor: 'printing' stamp: 'dt 1/12/2008 14:51'!
printOn: aStream

	aStream nextPutAll: self matcherName ! !

!MBPMatcher methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:21'!
publications
	^ publications! !

!MBPMatcher methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:21'!
publications: anObject
	publications := anObject! !

!MBPMatcher methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:17'!
vendor
	^ vendor! !

!MBPMatcher methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:17'!
vendor: anObject
	vendor := anObject! !

Object subclass: #MBPPerson
	instanceVariableNames: 'firstname lastname email homepage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-Model'!

!MBPPerson class methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 10:04'!
descriptionEmail

	^MAStringDescription new
		selectorAccessor: #email;
		label: 'E-mail address';
		priority: 30;
		yourself! !

!MBPPerson class methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 10:05'!
descriptionFirstname

	^MAStringDescription new
		selectorAccessor: #firstname;
		label: 'Firstname';
		priority: 10;
		beRequired;
		yourself! !

!MBPPerson class methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 10:04'!
descriptionHomepage

	^MAStringDescription new
		selectorAccessor: #homepage;
		label: 'Homepage';
		priority: 40;
		yourself! !

!MBPPerson class methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 10:05'!
descriptionLastname

	^MAStringDescription new
		selectorAccessor: #lastname;
		label: 'Lastname';
		priority: 20;
		beRequired;
		yourself! !

!MBPPerson methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:18'!
email
	^ email! !

!MBPPerson methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:18'!
email: anObject
	email := anObject! !

!MBPPerson methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:18'!
firstname
	^ firstname! !

!MBPPerson methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:18'!
firstname: anObject
	firstname := anObject! !

!MBPPerson methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:18'!
homepage
	^ homepage! !

!MBPPerson methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:18'!
homepage: anObject
	homepage := anObject! !

!MBPPerson methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:18'!
lastname
	^ lastname! !

!MBPPerson methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:18'!
lastname: anObject
	lastname := anObject! !

!MBPPerson methodsFor: 'printing' stamp: 'dt 1/12/2008 14:47'!
printOn: aStream

	aStream
		nextPutAll: self firstname;
		nextPutAll: ' ';
		nextPutAll: self lastname! !

Object subclass: #MBPPublication
	instanceVariableNames: 'title abstract authors year'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-Model'!

!MBPPublication class methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 10:12'!
descriptionAbstract

	^MAMemoDescription new
		selectorAccessor: #abstract;
		label: 'Abstract';
		priority: 20;
		beRequired;
		yourself! !

!MBPPublication class methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 16:50'!
descriptionAuthors

	^MAMultipleOptionDescription new
		selectorAccessor: #authors;
		label: 'Authors';
		priority: 30;
		options: [MBPDatabase default persons ] asDynamicObject;
		reference:  ((MBPPerson descriptionContainer)
					add: MBPPerson descriptionLastname;
					add: MBPPerson descriptionFirstname);
					yourself;
		yourself
		! !

!MBPPublication class methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 10:12'!
descriptionTitle

	^MAStringDescription new
		selectorAccessor: #title;
		label: 'Title';
		priority: 10;
		beRequired;
		yourself! !

!MBPPublication class methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 10:12'!
descriptionYear

	^MADateDescription new
		selectorAccessor: #year;
		label: 'Publication date';
		priority: 40;
		beRequired;
		yourself! !

!MBPPublication methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:19'!
abstract
	^ abstract! !

!MBPPublication methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:19'!
abstract: anObject
	abstract := anObject! !

!MBPPublication methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:19'!
authors
	^ authors! !

!MBPPublication methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:19'!
authors: anObject
	authors := anObject! !

!MBPPublication methodsFor: 'initialize-release' stamp: 'dt 12/28/2007 13:19'!
initalize
	
	authors := OrderedCollection new! !

!MBPPublication methodsFor: 'printing' stamp: 'dt 1/12/2008 14:49'!
printOn: aStream

	aStream
		nextPutAll: self title;
		nextPutAll: ' ('.
	self authors
		do: [:each | aStream nextPutAll: each lastname]
		separatedBy: [ aStream nextPutAll: ', '].
	aStream nextPutAll: ')'.! !

!MBPPublication methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:19'!
title
	^ title! !

!MBPPublication methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:19'!
title: anObject
	title := anObject! !

!MBPPublication methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:19'!
year
	^ year! !

!MBPPublication methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:19'!
year: anObject
	year := anObject! !

Object subclass: #MBPTestCase
	instanceVariableNames: 'testCaseDescription testCaseTitle solutionFile testCaseFiles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-Model'!

!MBPTestCase class methodsFor: 'descriptions-attributes' stamp: 'dt 1/6/2008 20:25'!
descriptionSolutionFile

	^MAFileDescription new
		kind: MAExternalFileModel;
		selectorAccessor: #solutionFile;
		label: 'Solution File';
		priority: 30;
		beRequired;
		yourself! !

!MBPTestCase class methodsFor: 'descriptions-attributes' stamp: 'dt 1/8/2008 22:10'!
descriptionTestCaseDescription

	^MAMemoDescription new
		selectorAccessor: #testCaseDescription;
		label: 'Benchmark Description';
		priority: 40;
		beRequired;
		yourself! !

!MBPTestCase class methodsFor: 'descriptions-attributes' stamp: 'dt 1/8/2008 22:10'!
descriptionTestCaseFiles

	^MAFileDescription new
		kind: MAExternalFileModel;
		selectorAccessor: #testCaseFiles;
		label: 'Testcase File';
		priority: 20;
		beRequired;
		yourself! !

!MBPTestCase class methodsFor: 'descriptions-attributes' stamp: 'dt 1/8/2008 22:11'!
descriptionTestCaseTitle

	^MAStringDescription new
		selectorAccessor: #testCaseTitle;
		label: 'Title';
		priority: 10;
		beRequired;
		yourself! !

!MBPTestCase methodsFor: 'printing' stamp: 'dt 1/12/2008 14:55'!
printOn: aStream

	aStream nextPutAll: self testCaseTitle ! !

!MBPTestCase methodsFor: 'accessing' stamp: 'dt 1/6/2008 20:24'!
solutionFile
	^ solutionFile! !

!MBPTestCase methodsFor: 'accessing' stamp: 'dt 1/6/2008 20:24'!
solutionFile: anObject
	solutionFile := anObject! !

!MBPTestCase methodsFor: 'accessing' stamp: 'dt 1/8/2008 22:12'!
testCaseDescription
	^ testCaseDescription! !

!MBPTestCase methodsFor: 'accessing' stamp: 'dt 1/8/2008 22:12'!
testCaseDescription: anObject
	testCaseDescription := anObject! !

!MBPTestCase methodsFor: 'accessing' stamp: 'dt 1/8/2008 22:12'!
testCaseFiles
	^ testCaseFiles! !

!MBPTestCase methodsFor: 'accessing' stamp: 'dt 1/8/2008 22:12'!
testCaseFiles: anObject
	testCaseFiles := anObject! !

!MBPTestCase methodsFor: 'accessing' stamp: 'dt 1/8/2008 22:12'!
testCaseTitle
	^ testCaseTitle! !

!MBPTestCase methodsFor: 'accessing' stamp: 'dt 1/8/2008 22:12'!
testCaseTitle: anObject
	testCaseTitle := anObject! !

Object subclass: #MBPTestCaseResult
	instanceVariableNames: 'filename submitter comment matcher uri testCase statistics uploadDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-Model'!

!MBPTestCaseResult class methodsFor: 'private' stamp: 'dt 1/12/2008 15:22'!
checkResultFile: aFile

	^ (aFile mimetype = 'text/xml')! !

!MBPTestCaseResult class methodsFor: 'description-attributes' stamp: 'dt 1/12/2008 15:05'!
ddescriptionBenchmark
	^ MASingleOptionDescription new
		selectorAccessor: #testCase ;
		label: 'Select Benchmark' ;
		priority: 5 ;
		beRequired ;
		options: (MBPDatabase default testCases) ;
		reference: (MBPTestCase descriptionContainer add: MBPTestCase descriptionTestCaseTitle) yourself ;
		yourself! !

!MBPTestCaseResult class methodsFor: 'description-attributes' stamp: 'dt 1/12/2008 15:18'!
descriptionComment

	^MAMemoDescription new
		selectorAccessor: #comment;
		label: 'Comment';
		priority: 30;
		addCondition: [:value | value isNil or: [value size <= 20]] labelled: 'Your comment is not strong enugh';
		yourself
		! !

!MBPTestCaseResult class methodsFor: 'description-attributes' stamp: 'dt 1/6/2008 19:56'!
descriptionFilename

	^MAFileDescription new
		kind: MAExternalFileModel;
		selectorAccessor: #filename;
		label: 'Matching file';
		addCondition: [:file | self checkResultFile: file ] labelled: 'File is not a valid result file';
		priority: 40;
		beRequired;
		yourself! !

!MBPTestCaseResult class methodsFor: 'description-attributes' stamp: 'dt 12/30/2007 17:59'!
descriptionMatcher

	^MASingleOptionDescription new
		selectorAccessor: #matcher;
		label: 'Select Matcher';
		priority: 10;
		beRequired;
		options: MBPDatabase default matchers;
		reference: ((MBPMatcher descriptionContainer)
			add: MBPMatcher descriptionMatcherName;
			yourself);
		yourself! !

!MBPTestCaseResult class methodsFor: 'description-attributes' stamp: 'dt 12/30/2007 18:00'!
descriptionSubmitter

	^MASingleOptionDescription new
		selectorAccessor: #submitter;
		beRequired;
		label: 'Submitter';
		priority: 20;
		options: [MBPDatabase default persons] asDynamicObject;
		reference: (MBPPerson descriptionContainer
			add: MBPPerson descriptionFirstname;
			add: MBPPerson descriptionLastname;
			yourself);
		yourself! !

!MBPTestCaseResult class methodsFor: 'description-attributes' stamp: 'dt 1/9/2008 09:23'!
descriptionTestCase
	^ MASingleOptionDescription new
		selectorAccessor: #testCase ;
		label: 'Select TestCase' ;
		priority: 5 ;
		beRequired ;
		options: MBPDatabase default benchmarks ;
		reference: (MBPBenchmark descriptionContainer add: MBPBenchmark descriptionBenchmarkTitle) yourself ;
		yourself! !

!MBPTestCaseResult class methodsFor: 'description-attributes' stamp: 'dt 1/7/2008 13:08'!
descriptionUploadDate

	^MADateDescription new
		selectorAccessor: #uploadDate;
		label: 'Upload Date';
		default: Date today;
		beReadonly;
		priority: 15;
		yourself! !

!MBPTestCaseResult methodsFor: 'accessing' stamp: 'dt 12/30/2007 17:57'!
comment
	^ comment! !

!MBPTestCaseResult methodsFor: 'accessing' stamp: 'dt 12/30/2007 17:57'!
comment: anObject
	comment := anObject! !

!MBPTestCaseResult methodsFor: 'accessing' stamp: 'dt 12/30/2007 11:53'!
filename
	^ filename! !

!MBPTestCaseResult methodsFor: 'accessing' stamp: 'dt 12/30/2007 11:53'!
filename: anObject
	filename := anObject! !

!MBPTestCaseResult methodsFor: 'initialize-release' stamp: 'dt 1/7/2008 10:34'!
initialize

	statistics := (Dictionary new)
		at: #truePositives put: OrderedCollection new;
		at: #falsePositives put: OrderedCollection new;
		at: #trueNegatives put: OrderedCollection new;
		at: #falseNegatives put: OrderedCollection new;
		yourself! !

!MBPTestCaseResult methodsFor: 'accessing' stamp: 'dt 12/30/2007 11:53'!
matcher
	^ matcher! !

!MBPTestCaseResult methodsFor: 'accessing' stamp: 'dt 12/30/2007 11:53'!
matcher: anObject
	matcher := anObject! !

!MBPTestCaseResult methodsFor: 'accessing' stamp: 'dt 1/7/2008 10:43'!
statistics
	^ statistics! !

!MBPTestCaseResult methodsFor: 'accessing' stamp: 'dt 1/7/2008 10:43'!
statistics: anObject
	statistics := anObject! !

!MBPTestCaseResult methodsFor: 'accessing' stamp: 'dt 12/30/2007 11:53'!
submitter
	^ submitter! !

!MBPTestCaseResult methodsFor: 'accessing' stamp: 'dt 12/30/2007 11:53'!
submitter: anObject
	submitter := anObject! !

!MBPTestCaseResult methodsFor: 'accessing' stamp: 'dt 1/8/2008 22:13'!
testCase
	^ testCase! !

!MBPTestCaseResult methodsFor: 'accessing' stamp: 'dt 1/8/2008 22:13'!
testCase: anObject
	testCase := anObject! !

!MBPTestCaseResult methodsFor: 'accessing' stamp: 'dt 1/7/2008 13:08'!
uploadDate
	^ uploadDate! !

!MBPTestCaseResult methodsFor: 'accessing' stamp: 'dt 1/7/2008 13:08'!
uploadDate: anObject
	uploadDate := anObject! !

!MBPTestCaseResult methodsFor: 'accessing' stamp: 'dt 12/30/2007 11:53'!
uri
	^ uri! !

!MBPTestCaseResult methodsFor: 'accessing' stamp: 'dt 12/30/2007 11:53'!
uri: anObject
	uri := anObject! !
